/**
 Trivial Windows CreateProcess() program.
 Orion Sky Lawlor, olawlor@acm.org, 2005/2/7 (Public Domain)
*/
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

enum {runTimes=20, delayLen=1*1000*1000};
int total=0;
void *run(void *ptr) {
	int threadNo=*(int *)ptr;
	for (int n=0;n<runTimes;n++) {
		for (int i=0;i<delayLen;i++) {}
		printf("%c: (it %d)  (total %d)\n",'A'+threadNo,n,total);
		total++;
	}
	return 0;
}

int main(int argc,char *argv[]) {
	int count=0;
	if (argc<=1) { /* create a second process */
		STARTUPINFO si={0};
		PROCESS_INFORMATION pi;
		CreateProcess(
		  0, /* program name */
		  "process_win.exe a b c", /* command line */
		  0,0,false,0,0,0, /* optional stuff */
		  &si,&pi /* startup information, process information */
		);
		count=0;
		run(&count);
	} else { /* we *are* the second process */
		count=1;
		run(&count);
	}
	return 0;
}
